deferred class
	AST_EIFFEL_FEATURE

inherit
	AST_DECLARATION
		redefine
			make_copy
		end
	ATTRIBUTE_SPECIFIER_INFO
		redefine
			make_copy
		end

feature {ANY}

	orig_c_identifier: STRING_8

	type: AST_TYPE
		deferred
		end

	storage_class_specifiers: LIST [INTEGER]

	is_extern: BOOLEAN
		do
			Result := storage_class_specifiers.has (C_kw_extern)
		end

feature {ANY}

	call_graph: CALL_GRAPH_NODE assign set_call_graph

	set_call_graph (a_call_graph: like call_graph)
		do
			call_graph := a_call_graph
		end

	oo_class_assignment_data: TUPLE [
			applied_heuristic: INTEGER_8
			removed_parameter: AST_VARIABLE_DECLARATION
			removed_parameter_index: INTEGER_32
			fixed: BOOLEAN -- can't be moved anymore
		] assign set_oo_class_assignment_data

	set_oo_class_assignment_data (a_oo_class_assignment_data: like oo_class_assignment_data)
		do
			oo_class_assignment_data := a_oo_class_assignment_data
		end

	oo_class: AST_STRUCT_DECLARATION assign set_oo_class

	set_oo_class (a_oo_class: AST_STRUCT_DECLARATION)
		do
			oo_class := a_oo_class
		end

feature {ANY} -- AST_NODE

	make_copy (a_other: like Current)
		do
			Precursor {AST_DECLARATION} (a_other)
			Precursor {ATTRIBUTE_SPECIFIER_INFO} (a_other)
			orig_c_identifier := a_other.orig_c_identifier -- won't be changed
			storage_class_specifiers := create {TWO_WAY_LIST [INTEGER]}.make
			across a_other.storage_class_specifiers as c loop
				storage_class_specifiers.extend (c.item)
			end
			oo_class := a_other.oo_class
		end

invariant
	orig_c_identifier /= Void and then not orig_c_identifier.is_empty
	storage_class_specifiers /= Void

end
