class
	AST_SIZEOF_EXPRESSION

inherit
	AST_EXPRESSION

create
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_node: AST_NODE)
		require
			a_node /= Void and then a_node.parent = Void
		do
			a_node.parent := Current
			node := a_node
		end

	make_from_antlr (a_node: ANTLR_AST_NODE; a_parent: AST_NODE)
		require
			a_node /= Void and then a_node.type = C_kw_sizeof
		do
			parent := a_parent

			inspect
				a_node.children.first.type
			when Ast_variable_declaration_or_type then
				node := process_type (a_node.children.first, Current)
			when Ast_expression then
				node := process_expression (a_node.children.first, Current)
			end
		end

feature {ANY}

	node: AST_NODE

	type_binding: AST_TYPE
		once ("OBJECT")
			Result := create {AST_BASIC_TYPE}.make (Ast_bt_unsigned_int)
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_sizeof_expression (Current)
			if visit_children then
				visit_node (node, v)
			end
			v.end_visit_sizeof_expression (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			node := other.node.ast_twin
			node.parent := Current
		end

invariant
	node /= Void

end
