class
	ASSIGNMENT_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_assignment_expression
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Transforming non-standard assignments"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION)
		local
			type: INTEGER
		do
			if node.type /= C_op_assign then
				-- `i *= 5 + 4' -> `i = i * (5 + 4)'
				inspect
					node.type
				when C_op_mult_assign then
					type := C_op_mult
				when C_op_div_assign then
					type := C_op_div
				when C_op_modulo_assign then
					type := C_op_modulo
				when C_op_plus_assign then
					type := C_op_plus
				when C_op_minus_assign then
					type := C_op_minus
				when C_op_left_shift_assign then
					type := C_op_left_shift
				when C_op_right_shift_assign then
					type := C_op_right_shift
				when C_op_bitand_assign then
					type := C_op_bitand
				when C_op_exor_assign then
					type := C_op_exor
				when C_op_bitor_assign then
					type := C_op_bitor
				end
				replace_node (node, create {AST_ASSIGNMENT_EXPRESSION}.make (
						node.target.ast_twin,
						create {AST_GENERIC_EXPRESSION}.make (
								type,
								node.target.ast_twin,
								create {AST_PARENTHESIZED_EXPRESSION}.make (node.source.ast_twin)
							)
					))
			end
		end

end
