deferred class
	DOT_VIEWER

inherit
	EXECUTION_ENVIRONMENT
	VIEW_INTERFACE

feature {ANY}

	show
		local
			l_dot_file: PLAIN_TEXT_FILE
		do
			if
				{PLATFORM}.is_unix and then
				attached get ("TMPDIR") as tmpdir and then
				attached find_program ("dot") as dot and then
				attached find_program ("okular") as okular
			then
				create l_dot_file.make_open_write (tmpdir + "/c2eif_tmp.dot")
				write_dot_file (l_dot_file)
				l_dot_file.close
				launch (dot + " " + l_dot_file.name + " -T pdf | " + okular + " - 2>/dev/null &")
			else
				log ("Showing dot file failed?!")
			end
		end

feature {NONE}

	write_dot_file (a_file: PLAIN_TEXT_FILE)
		require
			a_file /= Void and then a_file.is_open_write
		deferred
		end

feature {NONE}

	find_program (a_name: STRING_8): STRING_8
		require
			{PLATFORM}.is_unix
			a_name /= Void
		do
			if
				attached get ("PATH") as path and then
				attached path.split (':') as dirs
			then
				across
					dirs as c
				until
					Result /= Void
				loop
					if (create {DIRECTORY}.make (c.item)).has_entry (a_name) then
						Result := c.item + "/" + a_name
					end
				end
			end
		end

end
