class
	EV_INPUT_DIALOG

inherit
	EV_INFORMATION_DIALOG
		redefine
			initialize,
			set_text
		end

create
	default_create,
	make_with_text,
	make_with_text_and_actions

feature {NONE} -- Initialization

	initialize
			-- Initialize `Current'.
		local
			l_container: EV_CONTAINER
			l_vb: EV_VERTICAL_BOX
		do
			Precursor

			l_container := label.parent
			l_container.prune (label)

			create input_field

			create l_vb
			l_vb.extend (label)
			l_vb.extend (input_field)
			l_container.extend (l_vb)

			set_buttons (<<ev_ok, ev_cancel>>)
		end

feature {NONE}

	input_field: EV_TEXT_FIELD

feature {ANY}

	set_text (a_text: READABLE_STRING_GENERAL)
		do
			label.set_text (a_text)
		end

	set_input (a_input: STRING_8)
		require
			a_input /= Void
		do
			input_field.set_text (a_input)
		end

	input: STRING_8
		do
			Result := input_field.text
		ensure
			Result /= Void
		end

	ok_select_actions: EV_NOTIFY_ACTION_SEQUENCE
		do
			Result := ({EV_BUTTON} #? button_box[1]).select_actions
		end

	cancel_select_actions: EV_NOTIFY_ACTION_SEQUENCE
		do
			Result := ({EV_BUTTON} #? button_box[2]).select_actions
		end

invariant
	input_field /= Void

end
